/*
 * @author hornick
 */
package se1021.dateCalculator.YOURNAME;

/**
 * This class extracts day, month, and year values from a date string 
 * NOTE: This class does not display any output to the user; it is just a "worker" class
 */
public class DateStringConverter {
	
	// these variables represent month, day, and year.
	// range for month is 1-12; range for day is 1-31, and range for year is 0-9999
	private int month, day, year;
	
	/**
	 * constructor
	 * @param date - date string in EXACTLY the format mm/dd/yyyy (e.g. 12/31/2008 or 07/04/2008)
	 */
	public DateStringConverter(String date) {
//TODO make sure that the text field contains text; generate an Exception if NULL string or invalid length;
//TODO In the Exception, specify the reason: exactly what caused the error (NULL or invalid length).

		parseDateString( date );
	}
	/**
	 * handle the actual parsing of the date string
	 * @param date string in the format mm/dd/yyyy (e.g. 12/31/2008 or 07/04/2008)
	 * @throws Exception if the date string cannot be parsed according to the expected format
	 */
	private void parseDateString(String date) {
//TODO Modify this method's declaration to allow it to throw checked exceptions.
//TODO Surround the following statements with try-catch to trap parseInt-generated exceptions. 
//TODO Your code should include logic to determine exactly which field (month, day, year) was the source of error.
//TODO Once determined, specify that reason in an Exception you propagate to the caller of this method.
//TODO Note: DO NOT output JOptionPane or console messages here - that is is the job of the DateCalculator App! 
//TODO Note: No range checking is to be done here; that is done within the DaysCalculator constructor
		month = Integer.parseInt(date.substring(0,2)); //Gets month from first field
		day = Integer.parseInt(date.substring(3,5)); //Gets day from second field
		year = Integer.parseInt(date.substring(6,10)); //Gets year from third field
	}
	
	/**
	 * get the day corresponding to the date
	 * @return day of the month
	 */
	public int getDay() {
		return day;
	}
	
	/**
	 * get the month corresponding to the date
	 * @return month of the year
	 */
	public int getMonth() {
		return month;
	}
	
	/**
	 * get the year corresponding to the date
	 * @return year
	 */
	public int getYear() {
		return year;
	}

}
