/*
 * Created on Dec 14, 2007
 */
package se1021.dateCalculator.YOURNAME;

import java.util.GregorianCalendar;

/**
 * This class computes the number of days between two dates
 * NOTE: This class does not display any output to the user; it is just a "worker" class
 */
public class DaysCalculator {
	
	private static final int MS_TO_DAYS = 1000*60*60*24; // conversion factor for converting ms to days (ms/s)*(s/min)*(min/hr)*(hr/day)

	// these variables represent the starting and ending month, day, and year.
	// range for month is 1-12; range for day is 1-31, and range for year is 0-9999
	private int startDay,
			 	 startMonth,
			 	 startYear,
			 	 endDay,
			 	 endMonth,
			 	 endYear;
	
	/**
	 * Constructor for this class
	 * @param startDay numerical day of start date (1-31)
	 * @param startMonth numerical month of start date (1-12)
	 * @param startYear numerical year of start date (0-9999)
	 * @param endDay numerical day of end date (1-31)
	 * @param endMonth numerical day of end month (1-12)
	 * @param endYear numerical day of end year (0-9999)
	 * @throws Exception if the numerical values for the dates are invalid
	 */
// TODO modify this constructor to indicate that it throws exceptions
	public DaysCalculator( int startDay, int startMonth, int startYear, int endDay, int endMonth, int endYear ) {

// TODO throw Exceptions if any values are out of range; there are 6 different possible exception reasons, so
// TODO be sure to set the reason to the specific cause of the error

		this.startDay = startDay;
		this.startMonth = startMonth;
		this.startYear = startYear;
		this.endDay = endDay;
		this.endMonth = endMonth;
		this.endYear = endYear;
	}
	
	/**
	 * Computes the number of days between the two dates supplied to the constructor
	 * @return the number of days between dates
	 * @throws Exception if the End Date precedes the Start Date
	 */
// TODO modify this method to indicate that it throws Exceptions
	public int getDaysBetweenDates(){
		
		// Note: GregorianCalendar uses 0-based values for month (0-11) and day (0-30)
		GregorianCalendar calOne = new GregorianCalendar(startYear, startMonth-1, startDay-1); //Creates new calendar at "Begin Date"
		long millisStart = calOne.getTimeInMillis(); //Gets time in milliseconds from "Begin Date" calendar

		GregorianCalendar calTwo = new GregorianCalendar(endYear, endMonth-1, endDay-1); //Creates new calendar at "End Date"
		long millisEnd = calTwo.getTimeInMillis(); //Gets time in milliseconds from "End Date" calendar

		long diffMillis = millisEnd - millisStart; //Finds milliseconds between dates

		
		int numDays = (int)(diffMillis / MS_TO_DAYS); //Converts from milliseconds to days

// TODO throw an Exception if the End Date precedes the Start Date (numDays will be < 0)
// TODO be sure to set the Exception reason to indicate this.
		return numDays;
	}

}
